#ifndef _NEL_H_
#define _NEL_H_
#include "List.h"
#include <string>
using namespace std;

class NonEmptyList : public List {
	private:
		string first;
		List *rest;
	public:
		// constructors
		NonEmptyList (string f, List *r);
		NonEmptyList (const NonEmptyList &other);

		// access methods
		string getFirst () const;

		List *getRest () const;

		// other interesting methods
		int length (void) const;
};

#endif
