#ifndef _LIST_H_
#define _LIST_H_

#include <iostream>
#include <string>
using namespace std;

template<class C>
class List<C> {
public:
	virtual int length(void) const = 0;
	string description(void) const;
	template<class Result>
	virtual List<Result> *map(Result (*f)(C)) = 0;
// protected:
// I don't know why this doesn't compile as "protected".
	virtual string descrHelper(void) const = 0;
};

template <class C>
ostream & operator<< (ostream &s, const List<C> &the_list);
#endif
